<html lang="fr">
<head>
  <meta charset="utf-8">
  <title> TMC Annotations Generator - Init Format</title>
  <link rel="stylesheet" href="css/bootstrap.min.css">
  <script src="js/bootstrap.min.js"></script>
  <script src="js/main.js"></script>

</head>
<body>

 <br>
  <br>


<!-- Init Format -->
<div id="InitFormatDiv" class="input-group mb-3">
	<div class="input-group-prepend">
    	<label class="input-group-text" for="inputGroupSelect01">Init Format</label>
		<select class="custom-select" id="InitFormatOpcode">
    		<option value="000000" selected>Operation</option>
    		<option value="000000">(Mounir) Instr -- reg_dst = Instr </option>
		<option value="010000">(Mounir) SVC -- Syscall</option>	
		<option value="000001">LW -- reg_dst = Mem(reg_src + o􏰁ffset) </option>
		<option value="000010">SW -- Mem(reg_dst + o􏰁set) = reg_src</option>
		<option value="000011">LCR -- reg_dst_con􏰂g_register = Mem(reg_src + o􏰁set) </option>
		    <option value="000100">Write a TLB entry -- TLB[auto] = reg_src. </option>
		    <option value="000111">tag_rri -- reg_dst = reg_src + imm_16</option>
		    
		    <option value="100000">Tag_reg_imm -- reg_dst = imm </option>
		    <option value="100001">Tag_reg_reg tag -- reg_dst <= reg_src </option>
		    <option value="100010">Tag_mem_reg -- Mem([reg1_dst + o􏰁set] ) = reg2 </option>
		    <option value="101011">Lui -- reg_dst <= (imm_16􏰀16) | reg_src;</option>
		</select>
    
    	<select class="custom-select" id="InitFormatDestReg">
		    <option value="00000" selected>Destination Register</option>
		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>
		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
		</select>


		</select>
		    <select class="custom-select" id="InitFormatSrcReg">
		    <option value="00000" selected>Source Register</option>
		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>
		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
		</select>

 		<input class="custom-text" type="text" id="InitFormatImm">

		<div class="input-group-append">
			<button class="btn btn-outline-secondary" type="button" id="inputGroupFileAddon04" onclick="generateInitFormat()">Generate</button>
		</div>

	</div>

	<br>

	<div id="InitFormatValues">

		<table class="table table-bordered">
			<thead>
				<tr>
			      <th scope="col">Opcode</th>
			      <th scope="col">Destination Register</th>
			      <th scope="col">Source Register</th>
			      <th scope="col">Immediate</th>
		   		</tr>
		  	</thead>
		 	<tbody>
		    	<tr>
			      <td id="InitFormatOpcodeTab"></td>
			      <td id="InitFormatDestRegTab"></td>
			      <td id="InitFormatSrcRegTab"></td>
			      <td id="InitFormatImmTab"></td>
		    	</tr>
		  	</tbody>
		</table>

		<br>

		<div id="InitFormatValueBinaryDiv">Binary value: <div id="InitFormatValueBinary"></div></div><br>
		<div id="InitFormatValueHexadecimalDiv">Hexadecimal value:<div id="InitFormatValueHexadecimal"></div></div><br>
		<div id="InitFormatValueBinaryDiv">Integer value:<div id="InitFormatValueInteger"></div></div><br>

	</div>

</div>





<div id="TRFormatDiv" class="input-group mb-3">
	
	<div class="input-group-prepend">
		<label class="input-group-text" for="inputGroupSelect01">TR Format</label>
 
		<select class="custom-select" id="TRFormatOpcode">
			<option value="00000" selected>Operation</option>
			<option value="100011">TRR -- tag(reg_dst) = tag (reg_src1) OPERATION tag(reg_src2)</option>
		    <option value="100110">Tag_arith_log -- General purpose operations on GPR </option>
			<option value="101110">Tag_check_reg -- Check tag value of speci􏰂ed registers </option>
		</select>
	  


		<select class="custom-select" id="TRFormatArmopcodetype">
			<option value="0000" selected>ARM_OPCODE_TYPE</option>
		    <option value="0000">NULL</option>
		    <option value="0001">MOV</option>
		    <option value="0010">Arith/Logic</option>
		    <option value="0011">COMP</option>
		    <option value="0100">Arith/logic and COMP</option>
		    <option value="0101">FP MOV</option>
		    <option value="0110">FP Arith/Logic</option>
		    <option value="0111">FP CMP</option>
		    <option value="1000">CUSTOM1</option>
		    <option value="1001">CUSTOM2</option>
		    <option value="1010">CUSTOM3</option>
		    <option value="1011">CUSTOM4</option>
		    <option value="1100">Not implemented</option>
		    <option value="1101">Not implemented</option>
		    <option value="1110">Not implemented</option>
		    <option value="1111">Not implemented</option> 
	  	</select>
	  


		<select class="custom-select" id="TRFormatDestReg">
		    <option value="00000" selected>Destination Register</option>
		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>
		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
	  </select>

	  </select>
		    <select class="custom-select" id="TRFormatSrcReg1">
		    <option value="00000" selected>Source Register 1</option>

		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>

		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
		</select>


		</select>
		    <select class="custom-select" id="TRFormatSrcReg2">
		    <option value="00000" selected>Source Register 2</option>

		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>

		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
		</select>

		<select class="custom-select" id="TRFormatFUNC">
		    <option value="00000" selected>FUNC</option>
		    <option value="00010">ADD</option>
		    <option value="00011">SUB</option>
		    <option value="00100">OR</option>
		    <option value="00101">AND</option>
		    <option value="00110">XOR</option>
		    <option value="00111">NOR</option>
		    <option value="01000">copy_src_1</option>
		    <option value="01001">copy_src_2</option>
		</select>


	    <div class="input-group-append">
	    	<button class="btn btn-outline-secondary" type="button" id="inputGroupFileAddon04" onclick="generateTRFormat()">Generate</button>
	  	</div>
	</div>

	<div id="TRFormatValues">

		<table class="table table-bordered">
		  <thead>
		    <tr>
		      <th scope="col">Opcode</th>
		      <th scope="col">ARM_OPCODE_TYPE</th>
		      <th scope="col">Destination Register</th>
		      <th scope="col">Source Register 1</th>
		      <th scope="col">Source Register 2</th>
		      <th scope="col">FUNC</th>
		    </tr>
		  </thead>
		  <tbody>
		    <tr>
		      <td id="TRFormatOpcodeTab"></td>
		      <td id="TRFormatARMOpcodeTab"></td>
		      <td id="TRFormatDestRegTab"></td>
		      <td id="TRFormatSrc1RegTab"></td>
			  <td id="TRFormatSrc2RegTab"></td>
		      <td id="TRFormatFuncTab"></td>
		    </tr>
		  </tbody>
		</table>

		<div id="TRFormatValueBinaryDiv">Binary value: <div id="TRFormatValueBinary"></div></div> <br>
		<div id="TRFormatValueHexadecimalDiv">Hexadecimal value:<div id="TRFormatValueHexadecimal"></div></div>  <br>
		<div id="TRFormatValueIntegerDiv">Integer value:<div id="TRFormatValueInteger"></div></div>  <br>

	</div>

</div>



<div id="TIFormatDiv" class="input-group mb-3">

	<div class="input-group-prepend">
		<label class="input-group-text" for="inputGroupSelect01">TI Format</label>

		<select class="custom-select" id="TIFormatOpcode">
			<option value="000000" selected>Operation</option>
			<option value="100100">Tag_mem_tr -- tag (Mem(reg_dst + o􏰁set)) = tag(reg_src1)</option>
  		    <option value="100101">Tag_tr_mem -- tag(reg_dst) = tag (Mem(reg_src + o􏰁set))</option>
			<option value="101100">Tag_mem_tr_2 -- tag (Mem(reg_dst + o􏰁set)) = tag(reg_src1) </option>
			<option value="101101">Tag_tr_mem_2 -  tag(reg_dst) = tag (Mem(reg_src + o􏰁set))</option>
    		<option value="100111">Tag_instrumentation_tr -- Tag(Mem(instrumentation)) <= tag (reg_src1) (operation done for ARM STR register relative instructions) </option>
    		<option value="101000">Tag_tr_instrumentation - reg_dst <= tag(Mem(instrumentation)) (opreation done for ARM register relative LDR instructions) </option>
    		<option value="101001">Tag_Kblare_tr -- Mem(KBlare) <= tag (reg_src1) </option>
    		<option value="101010">Tag_tr_Kblare -- tag (reg_dest) <= Mem(KBlare)</option>
			<option value="101111">Tag_check_mem -- Check tag value of mem address speci􏰂ed in register (reg_src1 + o􏰁set) </option>
		</select>


  		<select class="custom-select" id="TIFormatArmopcodetype">
		    <option value="0000" selected>ARM_OPCODE_TYPE</option>
		    <option value="0000">NULL</option>
		    <option value="0001">MOV</option>
		    <option value="0010">Arith/Logic</option>
		    <option value="0011">COMP</option>
		    <option value="0100">Arith/logic and COMP</option>
		    <option value="0101">FP MOV</option>
		    <option value="0110">FP Arith/Logic</option>
		    <option value="0111">FP CMP</option>
		    <option value="1000">CUSTOM1</option>
		    <option value="1001">CUSTOM2</option>
		    <option value="1010">CUSTOM3</option>
		    <option value="1011">CUSTOM4</option>
		    <option value="1100">Not implemented</option>
		    <option value="1101">Not implemented</option>
		    <option value="1110">Not implemented</option>
		    <option value="1111">Not implemented</option>
		</select>

		<select class="custom-select" id="TIFormatDestReg">
		    <option value="00000" selected>Destination Register</option>
		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>
		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
		</select>

	    <select class="custom-select" id="TIFormatSrcReg">
		    <option value="00000" selected>Source Register</option>
		    <option value="00000">t0</option>
		    <option value="00001">t1</option>
		    <option value="00010">t2</option>
		    <option value="00011">t3</option>
		    <option value="00100">t4</option>
		    <option value="00101">t5</option>
		    <option value="00110">t6</option>
		    <option value="00111">t7</option>
		    <option value="01000">t8</option>
		    <option value="01001">t9</option>
		    <option value="01010">t10</option>
		    <option value="01011">t11</option>
		    <option value="01100">t12</option>
		    <option value="01101">t13</option>
		    <option value="01110">t14</option>
		    <option value="01111">t15</option>
		    <option value="10000">g1</option>
		    <option value="10001">g2</option>
		    <option value="10010">g3</option>
		    <option value="10011">g4</option>
		    <option value="10100">g5</option>
		    <option value="10101">g6</option>
		    <option value="10110">g7</option>
		    <option value="10111">g8</option>
		    <option value="11001">(Not used) g9</option>
		    <option value="11010">(Not used) g10</option>
		    <option value="11011">(Not used) g11</option>
		    <option value="11100">(Not used) g12</option>
		    <option value="11101">LR Value</option>
		    <option value="11110">SP Value</option>
		    <option value="11111">PC Value</option>
  		</select>

  		<input class="custom-text" type="text" id="TIFormatImm">

	    <div class="input-group-append">
    		<button class="btn btn-outline-secondary" type="button" id="inputGroupFileAddon04" onclick="generateTIFormat()">Generate</button>
  		</div>

	</div>


  	<div id="TIFormatValues">
  		
  		<table class="table table-bordered">
			<thead>
			    <tr>
			      <th scope="col">Opcode</th>
			      <th scope="col">ARM_OPCODE_TYPE</th>
			      <th scope="col">Destination Register</th>
			      <th scope="col">Source Register</th>
			      <th scope="col">Immediate</th>
			    </tr>
		  	</thead>

		  	<tbody>
			    <tr>
			      <td id="TIFormatOpcodeTab"></td>
			      <td id="TIFormatArmopcodetypeTab"></td>
			      <td id="TIFormatDestRegTab"></td>
			      <td id="TIFormatSrcRegTab"></td>
			      <td id="TIFormatImmTab"></td>
			    </tr>
		  	</tbody>
		</table>

		<div id="TIFormatValueBinaryDiv">Binary value:<div id="TIFormatValueBinary"></div></div> <br>
		<div id="TIFormatValueHexadecimalDiv">Hexadecimal value:<div id="TIFormatValueHexadecimal"></div></div> <br>
		<div id="TIFormatValueIntegerDiv">Integer value:<div id="TIFormatValueInteger"></div></div> <br>

	</div>

</div>


</body>
</html>
